%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  ׷Ʈ Steepest Descent
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;
clear all;
close all;
format short;

%%  Լ (  )

Q = [ 5 2 ; 2 1 ];
b = [ 3 1 ];

%   f = @(x) (1/2)*x'*Q*x - x*b'
 f = @(x1, x2) (5/2)* x1^2 + (1/2)* x2^2 + 2*x1*x2  - 3*x1 -x2 ;  % Exercise10.7
vf = @(x1, x2) (5/2)*x1.^2 + (1/2)*x2.^2 + 2*x1.*x2 - 3*x1 -x2 ;  % Exercise10.7

syms x1 x2;
gdf1 = diff( f(x1,x2), 'x1'); % x1 x2
gdf2 = diff( f(x1,x2), 'x2'); % x1 x2


%%  (  )

x0 = [ -1  4 ];          %  氡: ʱ Ž 
error = 0.001;          % 밡 (  Ž)

%% Լ ˰ (׷Ʈ, Ʈ) -   Ұ!!
prev_x = [];
prev_y = [];
for count=1:1:inf %(1) for-loop
    
       % ȭ  
       if count==1,
              scale = 1.0;  [ x y ] = meshgrid(-scale:0.01:scale , -scale:0.01:scale );
        end;        
        z = vf(x,y);       
        if count==1,
             figure(2);
             meshc(x,y,z);   
        end;
        figure(1);
        pw = f(x0(1),x0(2));
        contour(x,y,z,[pw pw]); hold on; grid on;
        plot( x0(1), x0(2) ,'r*'); %ȭ    

        prev_x = [ prev_x x0(1) ];     
        prev_y = [ prev_y x0(2) ];  
        if count>1,            
            plot( prev_x, prev_y ,'r-'); hold on;
        end;
        
       % ׸

               
        % ׷Ʈ 
        %fprintf('step(%d):  %2.4f   %2.4f   \n', count, x0(1), x0(2) ); % ȭ
        gdx  = [ subs(subs(gdf1, x0(1)),x0(2)) , subs(subs(gdf2, x0(1)),x0(2))  ];     % gd(׷Ʈ)
        syms  alpha; ax = x0 - alpha * gdx;
         g = @(alpha) subs(diff(  f( ax(1),ax(2) ), 'alpha' ));  % alpha Լ - Լ
%       zf = @(alpha) subs( f( ax(1),ax(2) )); 

        % SECANT Ž 
        x_ago = 16.0;           %  
        x_now = 15.9;           %  ǥ
        buffer=[ x_ago x_now ];     % Secant Method tangent x-  (ڵ)
     
        for scount=1:1:inf %(2)for-loop: ˰ 
                nom = g(x_now)*x_ago  - g(x_ago)*x_now;      % ڼ
                denom= g(x_now)   -  g(x_ago);               % и𼺺 
                next_x =nom/denom;                           % x ű ǥ 
                buffer = [ buffer, next_x ];                 % x ǥ 
    
                if g(next_x) < 0.001,                     % g(x)=0  ٻ  Ž 10^(-6)
                        alpha = next_x;
                        break;
                end; %(1) ּҰ Ȥ İ Ž 
         
                x_ago = x_now;   %  
                x_now = next_x;  %          
        end; % Secant 
        % SECANT Ž 
        
        if x0(1) < error & x0(2) <error,
                break;
        else,
            if count < 2
                fprintf('step(%d): X : %2.4f   %2.4f   ', count, x0(1), x0(2)); % ȭ
                fprintf('alpha: %2.5f\n',  alpha ); % ȭ
            else,
                fprintf('step(%d): X : %2.4f   %2.4f       g : %2.4f %2.4f\n ', count, x0(1), x0(2), g(1), g(2) ); % ȭ
                fprintf('     f(x) : %2.4f              alpha: %2.5f\n', f(x0(1),x0(2)),  alpha ); % ȭ
            end;
        end;
        
        next_x = x0 - alpha * gdx;           % next x  Ʈ 
        if norm(x0-next_x)/norm(x0) < error, %  Ž (NORM)  Ͽ
               break;
        end;             
        x0 = next_x;  % NEXT STEP    ʱȭ        
end; %(1) for-loop 


%% ȭ(  )
title('Steepest Descent Method in Search for minimizer');
xlabel('x');
ylabel('y');
  
  
  

% End of Program!!